//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
// original idea fr this indicator by Dan Valcu
//------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DimGray
#property indicator_color2 PaleVioletRed
#property indicator_width1 1
#property indicator_width2 2
#property indicator_level1 0

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern bool   BetterFormula       = false;
extern int    SignalPeriod        = 3;
extern int    SignalMethod        = MODE_SMA;
extern bool   alertsOn            = false;
extern bool   alertsOnZeroCross   = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;

double bhaOpn[];
double bhaClo[];
double haDelta[];
double haSignal[];
double trendz[];
double trends[];


string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(6);
   SetIndexBuffer(0, haDelta);
   SetIndexBuffer(1, haSignal);
   SetIndexBuffer(2, bhaOpn);
   SetIndexBuffer(3, bhaClo);
   SetIndexBuffer(4, trendz);
   SetIndexBuffer(5, trends);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" haDelta ("+SignalPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { haDelta[0] = MathMin(limit+1,Bars-1); return(0); }
          
   //
   //
   //
   //
   //
   
   if (timeFrame == Period())
   {
      for (int i=limit; i >= 0; i--)
      {
         double prOpen  = Open[i];
         double prClose = Close[i];
         double prLow   = Low[i];
         double prHigh  = High[i];

         if (BetterFormula) {
               if (prHigh!=prLow)
                     double haClose = (prOpen+prClose)/2.0+(((prClose-prOpen)/(prHigh-prLow))*MathAbs((prClose-prOpen)/2.0));
                     else   haClose = (prOpen+prClose)/2.0; }
          else              haClose = (prOpen+prHigh+prLow+prClose)/4;
                     double haOpen  = (bhaOpn[i+1]+bhaClo[i+1])/2.0;
                          bhaOpn[i] = haOpen;
                          bhaClo[i] = haClose;
                         haDelta[i] = haClose-haOpen;
                         }
                         
                         for (i=limit; i >= 0; i--)
                         {
                         haSignal[i]= iMAOnArray(haDelta,0,SignalPeriod,0,SignalMethod,i);
                           trendz[i]= trendz[i+1];
                           trends[i]= trends[i+1];
                           if (haDelta[i]>haSignal[i]) trends[i]= 1;
                           if (haDelta[i]<haSignal[i]) trends[i]=-1;
                           if (haDelta[i]>0)           trendz[i]= 1;
                           if (haDelta[i]<0)           trendz[i]=-1;
      }
      manageAlerts();
      return(0);
    }
     
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         haDelta[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,SignalPeriod,SignalMethod,0,y);
         haSignal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,SignalPeriod,SignalMethod,1,y);
         trendz[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,SignalPeriod,SignalMethod,5,y);
         trends[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,SignalPeriod,SignalMethod,6,y);
            if (haDelta[i]>haSignal[i]) trends[i]= 1;
            if (haDelta[i]<haSignal[i]) trends[i]=-1;
            if (haDelta[i]>0)           trendz[i]= 1;
            if (haDelta[i]<0)           trendz[i]=-1;
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnZeroCross && trendz[whichBar] != trendz[whichBar+1])
         {
            if (trendz[whichBar] ==  1) doAlert(time1,mess1,whichBar," haDelta crossed zero line up");
            if (trendz[whichBar] == -1) doAlert(time1,mess1,whichBar," haDelta crossed zero line down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trends[whichBar] != trends[whichBar+1])
         {
            if (trends[whichBar] ==  1) doAlert(time2,mess2,whichBar," haDelta crossed signal line up");
            if (trends[whichBar] == -1) doAlert(time2,mess2,whichBar," haDelta crossed signal line down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"haDelta "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


